class ExtendedLogger
  module Defaults
    def self.color_scheme
      ColorScheme::None
    end

    def self.log_format
      @log_format ||= -> message do
        time = message.time.strftime '%Y-%m-%dT%H:%M:%S.%6N'
        level = message.level.to_s.rjust 5

        "#{message.level.abbreviation}, [#{time} ##{$$}] #{level} -- #{message.label}: #{message.prose}"
      end
    end

    def self.levels
      level_names = %i(debug info warn error fatal)
      Level::Set.build level_names
    end
  end
end
