class ExtendedLogger
  class Level < Struct.new :name, :prev, :next
    include Comparable

    def <=> other
      self.ordinal <=> other.ordinal
    end

    def abbreviation
      label[0]
    end

    def ordinal
      @ordinal ||= if prev then prev.ordinal + 1 else 0 end
    end

    def label
      @label ||= name.to_s.upcase
    end

    def to_s
      label
    end
  end
end
