class ExtendedLogger
  class Serializer
    class TextFormatter
      attr_reader :prose

      def initialize prose
        @prose = prose
      end

      def self.call prose
        instance = new prose
        instance.()
      end

      def call
        return [ExtendedLogger.empty_message] if prose.nil? or prose.empty?

        lines.map do |line|
          line.chomp! if line.match %r{(?<!\r)\n}

          if line.empty?
            "\\n"
          else
            line = line.inspect
            line.slice! 0, 1
            line.slice! -1, 1
            line.gsub! '\\"', '"'
            line
          end
        end
      end

      def lines
        @lines ||= prose.each_line $INPUT_RECORD_SEPARATOR
      end
    end
  end
end
