class ExtendedLogger
  class VerbosityThreshold
    include Rule

    attr_accessor :level

    def initialize level
      @level = level
    end

    def call message
      if message.level >= level
        message
      end
    end

    def lower
      if level.next
        self.level = level.next
      end
    end

    def raise
      if level.prev
        self.level = level.prev
      end
    end
  end
end
